From a96cdf50bcae39a9ea7e1727d414293ce7ba0a91 Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Fri, 25 Apr 2014 19:55:35 -0700
Subject: [PATCH] Fixed issue by streamlining code to be more consistent.

* PKI TRAC Ticket #843 - Incorrect CLI argument parsing
---
 .../com/netscape/cmstools/cert/CertFindCLI.java    | 189 +++++++++++----------
 .../com/netscape/cmstools/cert/CertHoldCLI.java    |  28 +--
 .../netscape/cmstools/cert/CertReleaseHoldCLI.java |  28 +--
 .../netscape/cmstools/cert/CertRequestFindCLI.java |  85 ++++-----
 .../cmstools/cert/CertRequestProfileFindCLI.java   |  27 ++-
 .../cmstools/cert/CertRequestProfileShowCLI.java   |  34 ++--
 .../cmstools/cert/CertRequestReviewCLI.java        |  34 ++--
 .../netscape/cmstools/cert/CertRequestShowCLI.java |  27 +--
 .../cmstools/cert/CertRequestSubmitCLI.java        |  22 +--
 .../com/netscape/cmstools/cert/CertRevokeCLI.java  |  30 ++--
 .../com/netscape/cmstools/cert/CertShowCLI.java    |  32 ++--
 .../src/com/netscape/cmstools/cli/HelpCLI.java     |   2 +-
 .../src/com/netscape/cmstools/cli/MainCLI.java     |   8 +-
 .../cmstools/client/ClientCertFindCLI.java         |  29 +++-
 .../cmstools/client/ClientCertImportCLI.java       |  31 +++-
 .../cmstools/client/ClientCertRemoveCLI.java       |  22 ++-
 .../netscape/cmstools/client/ClientInitCLI.java    |  29 +++-
 .../com/netscape/cmstools/group/GroupAddCLI.java   |  24 +--
 .../com/netscape/cmstools/group/GroupFindCLI.java  |  23 ++-
 .../netscape/cmstools/group/GroupMemberAddCLI.java |  25 ++-
 .../cmstools/group/GroupMemberFindCLI.java         |  32 ++--
 .../cmstools/group/GroupMemberRemoveCLI.java       |  25 ++-
 .../cmstools/group/GroupMemberShowCLI.java         |  25 ++-
 .../netscape/cmstools/group/GroupModifyCLI.java    |  27 +--
 .../netscape/cmstools/group/GroupRemoveCLI.java    |  25 ++-
 .../com/netscape/cmstools/group/GroupShowCLI.java  |  25 ++-
 .../com/netscape/cmstools/key/KeyArchiveCLI.java   |  28 ++-
 .../src/com/netscape/cmstools/key/KeyFindCLI.java  |  25 ++-
 .../com/netscape/cmstools/key/KeyGenerateCLI.java  |  35 ++--
 .../com/netscape/cmstools/key/KeyModifyCLI.java    |  32 ++--
 .../com/netscape/cmstools/key/KeyRecoverCLI.java   |  28 ++-
 .../netscape/cmstools/key/KeyRequestFindCLI.java   |  25 ++-
 .../netscape/cmstools/key/KeyRequestReviewCLI.java |  32 ++--
 .../netscape/cmstools/key/KeyRequestShowCLI.java   |  17 +-
 .../com/netscape/cmstools/key/KeyRetrieveCLI.java  |  30 +++-
 .../src/com/netscape/cmstools/key/KeyShowCLI.java  |  20 ++-
 .../netscape/cmstools/key/KeyTemplateFindCLI.java  |  20 ++-
 .../netscape/cmstools/key/KeyTemplateShowCLI.java  |  21 ++-
 .../netscape/cmstools/logging/ActivityFindCLI.java |  23 ++-
 .../netscape/cmstools/logging/ActivityShowCLI.java |  25 ++-
 .../netscape/cmstools/logging/AuditModifyCLI.java  |  28 +--
 .../netscape/cmstools/logging/AuditShowCLI.java    |  28 +--
 .../netscape/cmstools/profile/ProfileAddCLI.java   |  23 +--
 .../cmstools/profile/ProfileDisableCLI.java        |  25 ++-
 .../cmstools/profile/ProfileEnableCLI.java         |  25 ++-
 .../netscape/cmstools/profile/ProfileFindCLI.java  |  27 ++-
 .../cmstools/profile/ProfileModifyCLI.java         |  23 +--
 .../cmstools/profile/ProfileRemoveCLI.java         |  25 ++-
 .../netscape/cmstools/profile/ProfileShowCLI.java  |  34 ++--
 .../cmstools/selftests/SelfTestFindCLI.java        |  23 ++-
 .../cmstools/selftests/SelfTestRunCLI.java         |  21 ++-
 .../cmstools/selftests/SelfTestShowCLI.java        |  28 +--
 .../cmstools/system/KRAConnectorAddCLI.java        |  21 +--
 .../cmstools/system/KRAConnectorRemoveCLI.java     |  25 ++-
 .../system/SecurityDomainGetInstallTokenCLI.java   |  28 +--
 .../cmstools/system/SecurityDomainShowCLI.java     |  21 ++-
 .../cmstools/system/TPSConnectorAddCLI.java        |  25 ++-
 .../cmstools/system/TPSConnectorFindCLI.java       |  25 ++-
 .../cmstools/system/TPSConnectorModCLI.java        |  27 ++-
 .../cmstools/system/TPSConnectorRemoveCLI.java     |  25 ++-
 .../cmstools/system/TPSConnectorShowCLI.java       |  33 ++--
 .../tps/authenticator/AuthenticatorAddCLI.java     |  24 +--
 .../tps/authenticator/AuthenticatorFindCLI.java    |  23 ++-
 .../tps/authenticator/AuthenticatorModifyCLI.java  |  28 +--
 .../tps/authenticator/AuthenticatorRemoveCLI.java  |  25 ++-
 .../tps/authenticator/AuthenticatorShowCLI.java    |  28 +--
 .../netscape/cmstools/tps/cert/TPSCertFindCLI.java |  23 ++-
 .../netscape/cmstools/tps/cert/TPSCertShowCLI.java |  25 ++-
 .../cmstools/tps/config/ConfigModifyCLI.java       |  34 ++--
 .../cmstools/tps/config/ConfigShowCLI.java         |  28 +--
 .../cmstools/tps/connection/ConnectionAddCLI.java  |  24 +--
 .../cmstools/tps/connection/ConnectionFindCLI.java |  23 ++-
 .../tps/connection/ConnectionModifyCLI.java        |  28 +--
 .../tps/connection/ConnectionRemoveCLI.java        |  25 ++-
 .../cmstools/tps/connection/ConnectionShowCLI.java |  28 +--
 .../cmstools/tps/profile/ProfileAddCLI.java        |  24 +--
 .../cmstools/tps/profile/ProfileFindCLI.java       |  23 ++-
 .../cmstools/tps/profile/ProfileMappingAddCLI.java |  24 +--
 .../tps/profile/ProfileMappingFindCLI.java         |  23 ++-
 .../tps/profile/ProfileMappingModifyCLI.java       |  28 +--
 .../tps/profile/ProfileMappingRemoveCLI.java       |  25 ++-
 .../tps/profile/ProfileMappingShowCLI.java         |  28 +--
 .../cmstools/tps/profile/ProfileModifyCLI.java     |  28 +--
 .../cmstools/tps/profile/ProfileRemoveCLI.java     |  25 ++-
 .../cmstools/tps/profile/ProfileShowCLI.java       |  28 +--
 .../netscape/cmstools/tps/token/TokenAddCLI.java   |  24 +--
 .../netscape/cmstools/tps/token/TokenFindCLI.java  |  23 ++-
 .../cmstools/tps/token/TokenModifyCLI.java         |  24 +--
 .../cmstools/tps/token/TokenRemoveCLI.java         |  25 ++-
 .../netscape/cmstools/tps/token/TokenShowCLI.java  |  25 ++-
 .../src/com/netscape/cmstools/user/UserAddCLI.java |  28 +--
 .../com/netscape/cmstools/user/UserCertAddCLI.java |  24 +--
 .../netscape/cmstools/user/UserCertFindCLI.java    |  32 ++--
 .../netscape/cmstools/user/UserCertRemoveCLI.java  |  25 ++-
 .../netscape/cmstools/user/UserCertShowCLI.java    |  38 ++---
 .../com/netscape/cmstools/user/UserFindCLI.java    |  23 ++-
 .../cmstools/user/UserMembershipAddCLI.java        |  25 ++-
 .../cmstools/user/UserMembershipFindCLI.java       |  32 ++--
 .../cmstools/user/UserMembershipRemoveCLI.java     |  25 ++-
 .../com/netscape/cmstools/user/UserModifyCLI.java  |  27 +--
 .../com/netscape/cmstools/user/UserRemoveCLI.java  |  25 ++-
 .../com/netscape/cmstools/user/UserShowCLI.java    |  25 ++-
 102 files changed, 1839 insertions(+), 1022 deletions(-)

diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertFindCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertFindCLI.java
index 333a3da..8c7a4df 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertFindCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertFindCLI.java
@@ -21,6 +21,7 @@ package com.netscape.cmstools.cert;
 import java.io.FileNotFoundException;
 import java.io.FileReader;
 import java.io.IOException;
+import java.util.Arrays;
 import java.util.Collection;
 import java.util.Date;
 
@@ -46,102 +47,15 @@ public class CertFindCLI extends CLI {
     public CertFindCLI(CertCLI certCLI) {
         super("find", "Find certificates", certCLI);
         this.certCLI = certCLI;
+
+        createOptions();
     }
 
     public void printHelp() {
         formatter.printHelp(getFullName() + " [OPTIONS...]", options);
     }
 
-    public void execute(String[] args) throws Exception {
-
-        addOptions();
-
-        CommandLine cmd = null;
-        CertSearchRequest searchData = null;
-        try {
-            cmd = parser.parse(options, args);
-        } catch (ParseException e) {
-            System.err.println("Error: " + e.getMessage());
-            printHelp();
-            System.exit(1);
-        }
-
-        if (cmd.hasOption("help")) {
-            // Display usage
-            printHelp();
-            System.exit(0);
-        }
-
-        String fileName = null;
-
-        if (cmd.hasOption("input")) {
-            fileName = cmd.getOptionValue("input");
-            if (fileName == null || fileName.length() < 1) {
-                System.err.println("Error: No file name specified.");
-                printHelp();
-                System.exit(1);
-            }
-        }
-
-        if (fileName != null) {
-            FileReader reader = null;
-            try {
-                reader = new FileReader(fileName);
-                searchData = CertSearchRequest.valueOf(reader);
-
-            } catch (FileNotFoundException e) {
-                System.err.println("Error: " + e.getMessage());
-                System.exit(1);
-
-            } catch (JAXBException e) {
-                System.err.println("Error: " + e.getMessage());
-                System.exit(1);
-
-            } finally {
-                if (reader != null)
-                    try {
-                        reader.close();
-                    } catch (IOException e) {
-                        e.printStackTrace();
-                    }
-            }
-
-        } else {
-            searchData = new CertSearchRequest();
-            searchData.setSerialNumberRangeInUse(true);
-        }
-
-        String s = cmd.getOptionValue("start");
-        Integer start = s == null ? null : Integer.valueOf(s);
-
-        s = cmd.getOptionValue("size");
-        Integer size = s == null ? null : Integer.valueOf(s);
-
-        addSearchAttribute(cmd, searchData);
-
-        CertDataInfos certs = certCLI.certClient.findCerts(searchData, start, size);
-
-        MainCLI.printMessage(certs.getTotal() + " entries found");
-        if (certs.getTotal() == 0) return;
-
-        boolean first = true;
-
-        Collection<CertDataInfo> entries = certs.getEntries();
-        for (CertDataInfo cert : entries) {
-            if (first) {
-                first = false;
-            } else {
-                System.out.println();
-            }
-
-            CertCLI.printCertInfo(cert);
-        }
-
-        MainCLI.printMessage("Number of entries returned " + certs.getEntries().size());
-    }
-
-    public void addOptions() {
-
+    public void createOptions() {
         Option option = null;
 
         //pagination options
@@ -277,6 +191,101 @@ public class CertFindCLI extends CLI {
         options.addOption(option);
     }
 
+    public void execute(String[] args) throws Exception {
+        // Always check for "--help" prior to parsing
+        if (Arrays.asList(args).contains("--help")) {
+            // Display usage
+            printHelp();
+            System.exit(0);
+        }
+
+        CommandLine cmd = null;
+
+        try {
+            cmd = parser.parse(options, args);
+        } catch (ParseException e) {
+            System.err.println("Error: " + e.getMessage());
+            printHelp();
+            System.exit(-1);
+        }
+
+        String[] cmdArgs = cmd.getArgs();
+
+        if (cmdArgs.length != 0) {
+            System.err.println("Error: Too many arguments specified.");
+            printHelp();
+            System.exit(-1);
+        }
+
+        CertSearchRequest searchData = null;
+        String fileName = null;
+
+        if (cmd.hasOption("input")) {
+            fileName = cmd.getOptionValue("input");
+            if (fileName == null || fileName.length() < 1) {
+                System.err.println("Error: No file name specified.");
+                printHelp();
+                System.exit(-1);
+            }
+        }
+
+        if (fileName != null) {
+            FileReader reader = null;
+            try {
+                reader = new FileReader(fileName);
+                searchData = CertSearchRequest.valueOf(reader);
+
+            } catch (FileNotFoundException e) {
+                System.err.println("Error: " + e.getMessage());
+                System.exit(-1);
+
+            } catch (JAXBException e) {
+                System.err.println("Error: " + e.getMessage());
+                System.exit(-1);
+
+            } finally {
+                if (reader != null)
+                    try {
+                        reader.close();
+                    } catch (IOException e) {
+                        e.printStackTrace();
+                    }
+            }
+
+        } else {
+            searchData = new CertSearchRequest();
+            searchData.setSerialNumberRangeInUse(true);
+        }
+
+        String s = cmd.getOptionValue("start");
+        Integer start = s == null ? null : Integer.valueOf(s);
+
+        s = cmd.getOptionValue("size");
+        Integer size = s == null ? null : Integer.valueOf(s);
+
+        addSearchAttribute(cmd, searchData);
+
+        CertDataInfos certs = certCLI.certClient.findCerts(searchData, start, size);
+
+        MainCLI.printMessage(certs.getTotal() + " entries found");
+        if (certs.getTotal() == 0) return;
+
+        boolean first = true;
+
+        Collection<CertDataInfo> entries = certs.getEntries();
+        for (CertDataInfo cert : entries) {
+            if (first) {
+                first = false;
+            } else {
+                System.out.println();
+            }
+
+            CertCLI.printCertInfo(cert);
+        }
+
+        MainCLI.printMessage("Number of entries returned " + certs.getEntries().size());
+    }
+
     public Long convertValidityDurationUnit(String unit) {
 
         if (unit.equalsIgnoreCase("day")) {
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertHoldCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertHoldCLI.java
index eb4f619..a4b1848 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertHoldCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertHoldCLI.java
@@ -20,6 +20,7 @@ package com.netscape.cmstools.cert;
 
 import java.io.BufferedReader;
 import java.io.InputStreamReader;
+import java.util.Arrays;
 
 import netscape.security.x509.RevocationReason;
 
@@ -44,19 +45,29 @@ public class CertHoldCLI extends CLI {
     public CertHoldCLI(CertCLI certCLI) {
         super("hold", "Place certificate on-hold", certCLI);
         this.certCLI = certCLI;
+
+        createOptions();
     }
 
     public void printHelp() {
         formatter.printHelp(getFullName() + " <Serial Number> [OPTIONS...]", options);
     }
 
-    public void execute(String[] args) throws Exception {
-
+    public void createOptions() {
         Option option = new Option(null, "comments", true, "Comments");
         option.setArgName("comments");
         options.addOption(option);
 
         options.addOption(null, "force", false, "Force");
+    }
+
+    public void execute(String[] args) throws Exception {
+        // Always check for "--help" prior to parsing
+        if (Arrays.asList(args).contains("--help")) {
+            // Display usage
+            printHelp();
+            System.exit(0);
+        }
 
         CommandLine cmd = null;
 
@@ -66,20 +77,15 @@ public class CertHoldCLI extends CLI {
         } catch (Exception e) {
             System.err.println("Error: " + e.getMessage());
             printHelp();
-            System.exit(1);
-        }
-
-        if (cmd.hasOption("help")) {
-            // Display usage
-            printHelp();
-            System.exit(0);
+            System.exit(-1);
         }
 
         String[] cmdArgs = cmd.getArgs();
 
         if (cmdArgs.length != 1) {
+            System.err.println("Error: Missing Serial Number.");
             printHelp();
-            System.exit(1);
+            System.exit(-1);
         }
 
         CertId certID = new CertId(cmdArgs[0]);
@@ -98,7 +104,7 @@ public class CertHoldCLI extends CLI {
             BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
             String line = reader.readLine();
             if (!line.equalsIgnoreCase("Y")) {
-                System.exit(1);
+                System.exit(-1);
             }
         }
 
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertReleaseHoldCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertReleaseHoldCLI.java
index 5917a01..42a8ae9 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertReleaseHoldCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertReleaseHoldCLI.java
@@ -20,6 +20,7 @@ package com.netscape.cmstools.cert;
 
 import java.io.BufferedReader;
 import java.io.InputStreamReader;
+import java.util.Arrays;
 
 import org.apache.commons.cli.CommandLine;
 
@@ -41,15 +42,25 @@ public class CertReleaseHoldCLI extends CLI {
     public CertReleaseHoldCLI(CertCLI certCLI) {
         super("release-hold", "Place certificate off-hold", certCLI);
         this.certCLI = certCLI;
+
+        createOptions();
     }
 
     public void printHelp() {
         formatter.printHelp(getFullName() + " <Serial Number> [OPTIONS...]", options);
     }
 
-    public void execute(String[] args) throws Exception {
-
+    public void createOptions() {
         options.addOption(null, "force", false, "Force");
+    }
+
+    public void execute(String[] args) throws Exception {
+        // Always check for "--help" prior to parsing
+        if (Arrays.asList(args).contains("--help")) {
+            // Display usage
+            printHelp();
+            System.exit(0);
+        }
 
         CommandLine cmd = null;
 
@@ -59,20 +70,15 @@ public class CertReleaseHoldCLI extends CLI {
         } catch (Exception e) {
             System.err.println("Error: " + e.getMessage());
             printHelp();
-            System.exit(1);
-        }
-
-        if (cmd.hasOption("help")) {
-            // Display usage
-            printHelp();
-            System.exit(0);
+            System.exit(-1);
         }
 
         String[] cmdArgs = cmd.getArgs();
 
         if (cmdArgs.length != 1) {
+            System.err.println("Error: Missing Serial Number.");
             printHelp();
-            System.exit(1);
+            System.exit(-1);
         }
 
         CertId certID = new CertId(cmdArgs[0]);
@@ -91,7 +97,7 @@ public class CertReleaseHoldCLI extends CLI {
             BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
             String line = reader.readLine();
             if (!line.equalsIgnoreCase("Y")) {
-                System.exit(1);
+                System.exit(-1);
             }
         }
 
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java
index 8024a04..2d8779d 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java
@@ -18,6 +18,7 @@
 
 package com.netscape.cmstools.cert;
 
+import java.util.Arrays;
 import java.util.Collection;
 
 import org.apache.commons.cli.CommandLine;
@@ -40,17 +41,56 @@ public class CertRequestFindCLI extends CLI {
     public CertRequestFindCLI(CertCLI certCLI) {
         super("request-find", "Find certificate requests", certCLI);
         this.certCLI = certCLI;
+
+        createOptions();
     }
 
     public void printHelp() {
         formatter.printHelp(getFullName() + " [OPTIONS...]", options);
     }
 
-    public void execute(String[] args) throws Exception {
+    public void createOptions() {
+        Option option = null;
+
+        // request state
+        option = new Option(null, "status", true, "Request status (pending, cancelled, rejected, complete, all)");
+        option.setArgName("status");
+        options.addOption(option);
 
-        addOptions();
+        // request type
+        option = new Option(null, "type", true, "Request type (enrollment, renewal, revocation, all)");
+        option.setArgName("type");
+        options.addOption(option);
+
+        //pagination options
+        option = new Option(null, "start", true, "Page start");
+        option.setArgName("start");
+        options.addOption(option);
+
+        option = new Option(null, "size", true, "Page size");
+        option.setArgName("size");
+        options.addOption(option);
+
+        //search limits
+        option = new Option(null, "maxResults", true, "Maximum number of results");
+        option.setArgName("maxResults");
+        options.addOption(option);
+
+        option = new Option(null, "timeout", true, "Search timeout");
+        option.setArgName("maxTime");
+        options.addOption(option);
+    }
+
+    public void execute(String[] args) throws Exception {
+        // Always check for "--help" prior to parsing
+        if (Arrays.asList(args).contains("--help")) {
+            // Display usage
+            printHelp();
+            System.exit(0);
+        }
 
         CommandLine cmd = null;
+
         try {
             cmd = parser.parse(options, args);
         } catch (ParseException e) {
@@ -59,10 +99,12 @@ public class CertRequestFindCLI extends CLI {
             System.exit(-1);
         }
 
-        if (cmd.hasOption("help")) {
-            // Display usage
+        String[] cmdArgs = cmd.getArgs();
+
+        if (cmdArgs.length != 0) {
+            System.err.println("Error: Too many arguments specified.");
             printHelp();
-            System.exit(0);
+            System.exit(-1);
         }
 
         String s = cmd.getOptionValue("start");
@@ -103,37 +145,4 @@ public class CertRequestFindCLI extends CLI {
 
         MainCLI.printMessage("Number of entries returned " + entries.size());
     }
-
-    public void addOptions() {
-
-        Option option = null;
-
-        // request state
-        option = new Option(null, "status", true, "Request status (pending, cancelled, rejected, complete, all)");
-        option.setArgName("status");
-        options.addOption(option);
-
-        // request type
-        option = new Option(null, "type", true, "Request type (enrollment, renewal, revocation, all)");
-        option.setArgName("type");
-        options.addOption(option);
-
-        //pagination options
-        option = new Option(null, "start", true, "Page start");
-        option.setArgName("start");
-        options.addOption(option);
-
-        option = new Option(null, "size", true, "Page size");
-        option.setArgName("size");
-        options.addOption(option);
-
-        //search limits
-        option = new Option(null, "maxResults", true, "Maximum number of results");
-        option.setArgName("maxResults");
-        options.addOption(option);
-
-        option = new Option(null, "timeout", true, "Search timeout");
-        option.setArgName("maxTime");
-        options.addOption(option);
-    }
 }
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestProfileFindCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestProfileFindCLI.java
index 85616a9..d36fb59 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestProfileFindCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestProfileFindCLI.java
@@ -1,5 +1,6 @@
 package com.netscape.cmstools.cert;
 
+import java.util.Arrays;
 import java.util.Collection;
 
 import org.apache.commons.cli.CommandLine;
@@ -19,14 +20,15 @@ public class CertRequestProfileFindCLI extends CLI {
     public CertRequestProfileFindCLI(CertCLI certCLI) {
         super("request-profile-find", "List Enrollment templates", certCLI);
         this.certCLI = certCLI;
+
+        createOptions();
     }
 
     public void printHelp() {
-        formatter.printHelp(getFullName() + " <Profile ID>", options);
+        formatter.printHelp(getFullName() + " <Profile ID> [OPTIONS...]", options);
     }
 
-    public void execute(String[] args) throws Exception {
-
+    public void createOptions() {
         Option option = new Option(null, "start", true, "Page start");
         option.setArgName("start");
         options.addOption(option);
@@ -34,6 +36,15 @@ public class CertRequestProfileFindCLI extends CLI {
         option = new Option(null, "size", true, "Page size");
         option.setArgName("size");
         options.addOption(option);
+    }
+
+    public void execute(String[] args) throws Exception {
+        // Always check for "--help" prior to parsing
+        if (Arrays.asList(args).contains("--help")) {
+            // Display usage
+            printHelp();
+            System.exit(0);
+        }
 
         CommandLine cmd = null;
 
@@ -43,13 +54,15 @@ public class CertRequestProfileFindCLI extends CLI {
         } catch (ParseException e) {
             System.err.println("Error: " + e.getMessage());
             printHelp();
-            System.exit(1);
+            System.exit(-1);
         }
 
-        if (cmd.hasOption("help")) {
-            // Display usage
+        String[] cmdArgs = cmd.getArgs();
+
+        if (cmdArgs.length != 1) {
+            System.err.println("Error: Missing Profile ID.");
             printHelp();
-            System.exit(0);
+            System.exit(-1);
         }
 
         String s = cmd.getOptionValue("start");
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestProfileShowCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestProfileShowCLI.java
index 396eca6..8b62670 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestProfileShowCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestProfileShowCLI.java
@@ -1,5 +1,7 @@
 package com.netscape.cmstools.cert;
 
+import java.util.Arrays;
+
 import org.apache.commons.cli.CommandLine;
 import org.apache.commons.cli.Option;
 import org.apache.commons.cli.ParseException;
@@ -16,18 +18,29 @@ public class CertRequestProfileShowCLI extends CLI {
     public CertRequestProfileShowCLI(CertCLI certCLI) {
         super("request-profile-show", "Get Enrollment template", certCLI);
         this.certCLI = certCLI;
+
+        createOptions();
     }
 
     public void printHelp() {
-        formatter.printHelp(getFullName() + " <Profile ID>", options);
+        formatter.printHelp(getFullName() + " <Profile ID> [OPTIONS...]", options);
     }
 
-    public void execute(String[] args) throws Exception {
-        CommandLine cmd = null;
-
+    public void createOptions() {
         Option option = new Option(null, "output", true, "Output filename");
         option.setArgName("filename");
         options.addOption(option);
+    }
+
+    public void execute(String[] args) throws Exception {
+        // Always check for "--help" prior to parsing
+        if (Arrays.asList(args).contains("--help")) {
+            // Display usage
+            printHelp();
+            System.exit(0);
+        }
+
+        CommandLine cmd = null;
 
         try {
             cmd = parser.parse(options, args);
@@ -37,20 +50,15 @@ public class CertRequestProfileShowCLI extends CLI {
             System.exit(-1);
         }
 
-        if (cmd.hasOption("help")) {
-            // Display usage
-            printHelp();
-            System.exit(0);
-        }
+        String[] cmdArgs = cmd.getArgs();
 
-        String[] cLineArgs = cmd.getArgs();
-        if (cLineArgs.length < 1) {
-            System.err.println("Error: Missing profile ID.");
+        if (cmdArgs.length < 1) {
+            System.err.println("Error: Missing Profile ID.");
             printHelp();
             System.exit(-1);
         }
 
-        String profileId = cLineArgs[0];
+        String profileId = cmdArgs[0];
 
         String filename = null;
         if (cmd.hasOption("output")) {
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestReviewCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestReviewCLI.java
index 672b7b5..4a8221b 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestReviewCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestReviewCLI.java
@@ -32,6 +32,8 @@ public class CertRequestReviewCLI extends CLI {
     public CertRequestReviewCLI(CertCLI certCLI) {
         super("request-review", "Review certificate request", certCLI);
         this.certCLI = certCLI;
+
+        createOptions();
     }
 
     @Override
@@ -39,10 +41,7 @@ public class CertRequestReviewCLI extends CLI {
         formatter.printHelp(getFullName() + " <Request ID> [OPTIONS...]", options);
     }
 
-    @Override
-    public void execute(String[] args) throws Exception {
-        CommandLine cmd = null;
-
+    public void createOptions() {
         Option option = new Option(null, "action", true, "Action: " + StringUtils.join(actions, ", "));
         option.setArgName("action");
         options.addOption(option);
@@ -50,6 +49,18 @@ public class CertRequestReviewCLI extends CLI {
         option = new Option(null, "file", true, "File to store the certificate request");
         option.setArgName("filename");
         options.addOption(option);
+    }
+
+    @Override
+    public void execute(String[] args) throws Exception {
+        // Always check for "--help" prior to parsing
+        if (Arrays.asList(args).contains("--help")) {
+            // Display usage
+            printHelp();
+            System.exit(0);
+        }
+
+        CommandLine cmd = null;
 
         try {
             cmd = parser.parse(options, args);
@@ -59,24 +70,19 @@ public class CertRequestReviewCLI extends CLI {
             System.exit(-1);
         }
 
-        if (cmd.hasOption("help")) {
-            // Display usage
-            printHelp();
-            System.exit(0);
-        }
+        String[] cmdArgs = cmd.getArgs();
 
-        String[] cLineArgs = cmd.getArgs();
-        if (cLineArgs.length < 1) {
-            System.err.println("Error: Missing certificate request ID.");
+        if (cmdArgs.length < 1) {
+            System.err.println("Error: Missing Certificate Request ID.");
             printHelp();
             System.exit(-1);
         }
 
         RequestId requestId = null;
         try {
-            requestId = new RequestId(cLineArgs[0]);
+            requestId = new RequestId(cmdArgs[0]);
         } catch (NumberFormatException e) {
-            System.err.println("Error: Invalid certificate request ID " + cLineArgs[0] + ".");
+            System.err.println("Error: Invalid certificate request ID " + cmdArgs[0] + ".");
             System.exit(-1);
         }
 
